﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Public Battery As String
	Public Time As String
	Public udptello As UDPSocket
	Private localport,RcvBufSize As Int
	Public telloip As String
	Public telloport As String
	
	Public ResponseTelloMsg As String			'Get UDP response msg from Tello	
	Public SendCommand As String				'Record command send to Tello
	Public tellocommands (16) As String
		
	Dim Packet As UDPPacket						'Packet to send
	Dim data() As Byte							'Command to send
	
End Sub

'Initializes the Tello object. You can add parameters to this method if needed.
'IP Tello,Tello UDP port,Timeout
Public Sub Initialize (localportvalue As String, RcvBufSizevalue As Int, telloipvalue As String, telloportvalue As String):
	localport=localportvalue
	RcvBufSize=RcvBufSizevalue
	telloip=telloipvalue
	telloport=telloportvalue
	udptello.Initialize("UDP", localportvalue,RcvBufSizevalue)
	
	'Tello commands covered by Tello SDK
	tellocommands=Array As String("command","takeoff", _
	"land","up","down","left","right","forward","back","cw","ccw","flip", _
	"speed","speed? ","battery?","time?")
	
	'We need to send "command" before sending more commands to Tello Drone
	SendCommand=tellocommands(0)
	SendUDPPacket(SendCommand)
	
End Sub

'Send UDP Packet
Public Sub SendUDPPacket(cmd As String)
	Dim Packet As UDPPacket
	data=cmd.GetBytes("UTF-8")
	Packet.Initialize(data,telloip,telloport)
	udptello.Send(Packet)
End Sub

'Send Command and get Responses 'OK-FALSE'
Public Sub Command
	SendCommand=tellocommands(0)
	SendUDPPacket(SendCommand)
End Sub

'Auto takeoff get responses 'OK FALSE'
Public Sub TakeOff
	SendCommand=tellocommands(1)
	'udptello.Initialize("UDP", localport, RcvBufSize)
	SendUDPPacket(SendCommand)
End Sub

'Auto landing get responses 'OK FALSE'
Public Sub Land
	SendCommand=tellocommands(2)
	'udptello.Initialize("UDP", localport, RcvBufSize)
	SendUDPPacket(SendCommand)
End Sub

'Fly upward xx/ xx = (20-500 cm) get responses 'OK FALSE OUT OF RANGE'
Public Sub Up (value As Int)
	SendCommand=$"${tellocommands(3)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Fly downward xx /xx = (20-500 cm) get responses 'OK FALSE OUT OF RANGE'
Public Sub Down (value As Int)
	SendCommand=$"${tellocommands(4)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Fly left xx/ xx = (20-500 cm) get responses 'OK FALSE OUT OF RANGE'
Public Sub Left (value As Int)
	SendCommand=$"${tellocommands(5)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Fly right xx/xx = (20-500 cm) get responses 'OK FALSE OUT OF RANGE'
Public Sub Right (value As Int)
	SendCommand=$"${tellocommands(6)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Fly forward xx/xx = (20-500 cm) get responses 'OK FALSE OUT OF RANGE'
Public Sub Forward (value As Int)
	SendCommand=$"${tellocommands(7)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Fly backward xx/xx = (20-500 cm) get responses 'OK FALSE OUT OF RANGE'
Public Sub Back (value As Int)
	SendCommand=$"${tellocommands(8)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Rotate clockwise xx /xx = (1-3600°) get responses 'OK FALSE OUT OF RANGE'
Public Sub Cw (value As Int)
	SendCommand=$"${tellocommands(9)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Rotate counter-clockwise xx/ xx = (1-3600°) get responses 'OK FALSE OUT OF RANGE'
Public Sub CCw (value As Int)
	SendCommand=$"${tellocommands(10)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Flip x Where l = (left) r = (right) f = (forward)  b = (back) 
'  bl = (Back/Left) rb = (Back/Right) 
' fl = (front/Left) fr = (front/Right) get responses 'OK FALSE OUT OF RANGE'
Public Sub Flip (value As String)
	SendCommand=$"${tellocommands(11)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Set current speed as xx/xx = (1-100 cm/s) get responses 'OK FALSE OUT OF RANGE'
Public Sub SetSpeed (value As String)
	SendCommand=$"${tellocommands(12)} ${value}"$ 
	SendUDPPacket(SendCommand)
End Sub

'Get current Speed get responses 'xx'
Public Sub GetSpeed
	SendCommand=tellocommands(13)
	SendUDPPacket(SendCommand)
End Sub

'Get current Battery get responses 'xx'
Public Sub GetBattery
	SendCommand=tellocommands(14)
	SendUDPPacket(SendCommand)
End Sub

'Get current Time Flight get responses 'xx'
Public Sub GetTimeFlight
	SendCommand=tellocommands(15)
	SendUDPPacket(SendCommand)
End Sub

Sub UDP_PacketArrived (Packet1 As UDPPacket)
	Dim msg As String
	msg = BytesToString(Packet1.Data, Packet1.Offset, Packet1.Length, "UTF8")
	ResponseTelloMsg=  "Message received: " & SendCommand & " :" & msg
End Sub

'										 Tello.Py


'"""License.
'Copyright 2018 Todd Mueller <firstnamelastname@gmail.com>
'This program Is free software: you can redistribute it And/Or modify
'it under the terms of the GNU General Public License As published by
'the Free Software Foundation, either version 3 of the License, Or
'(at your option) any later version.
'This program Is distributed In the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the
'GNU General Public License For more details.
'You should have received a copy of the GNU General Public License
'along with this program.  If Not, see <http://www.gnu.org/licenses/>.
'"""
'
'import socket
'import threading
'import Time
'import traceback
'
'class Tello:
'    """Wrapper to simply interactions with the Ryze Tello drone."""
'
'    def __init__(self, local_ip, local_port, imperial=True, command_timeout=.3, tello_ip='192.168.10.1', tello_port=8889):
'        """Binds to the local IP/port and puts the Tello into command mode.
'        Args:
'            local_ip (str): Local IP address To bind.
'            local_port (int): Local port To bind.
'            imperial (bool): If True, speed Is MPH And distance Is feet.
'                             If False, speed Is KPH And distance Is meters.
'            command_timeout (int|float): Number of seconds To wait For a response To a Command.
'            tello_ip (str): Tello IP.
'            tello_port (int): Tello port.
'        Raises:
'            RuntimeError: If the Tello rejects the attempt To enter Command mode.
'        """
'
'        self.abort_flag = False
'        self.command_timeout = command_timeout
'        self.imperial = imperial
'        self.response = None
'        self.socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
'        self.tello_address = (tello_ip, tello_port)
'
'        self.socket.bind((local_ip, local_port))
'
'        self.receive_thread = threading.Thread(target=self._receive_thread)
'        self.receive_thread.daemon=True
'
'        self.receive_thread.start()
'
'        If self.send_command('command') != 'OK':
'            raise RuntimeError('Tello rejected attempt to enter command mode')
'
'    def __del__(self):
'        """Closes the local socket."""
'
'        self.socket.close()
'
'    def _receive_thread(self):
'        """Listens for responses from the Tello.
'        Runs As a thread, sets self.response To whatever the Tello last returned.
'        """
'        While True:
'            Try:
'                self.response, ip = self.socket.recvfrom(256)
'            except Exception:
'                break
'
'    def Flip(self, direction):
'        """Flips.
'        Args:
'            direction (str): Direction To Flip, 'l', 'r', 'f', 'b', 'lb', 'lf', 'rb' or 'rf'.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        Return self.send_command('flip %s' % direction)
'
'    def get_battery(self):
'        """Returns percent battery life remaining.
'        Returns:
'            int: Percent Battery life remaining.
'        """
'
'        Battery = self.send_command('battery?')
'
'        Try:
'            Battery = int(Battery)
'        except:
'            pass
'
'        Return Battery
'
'
'    def get_flight_time(self):
'        """Returns the number of seconds elapsed during flight.
'        Returns:
'            int: Seconds elapsed during flight.
'        """
'
'        flight_time = self.send_command('time?')
'
'        Try:
'            flight_time = int(flight_time)
'        except:
'            pass
'
'        Return flight_time
'
'    def get_speed(self):
'        """Returns the current speed.
'        Returns:
'            int: Current speed in KPH Or MPH.
'        """
'
'        speed = self.send_command('speed?')
'
'        Try:
'            speed = float(speed)
'
'            If self.imperial Is True:
'                speed = Round((speed / 44.704), 1)
'            Else:
'                speed = Round((speed / 27.7778), 1)
'        except:
'            pass
'
'        Return speed
'
'    def Land(self):
'        """Initiates landing.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        Return self.send_command('land')
'
'    def move(self, direction, distance):
'        """Moves in a direction for a distance.
'        This method expects meters Or feet. The Tello API expects distances
'        from 20 To 500 centimeters.
'        Metric: .1 To 5 meters
'        Imperial: .7 To 16.4 feet
'        Args:
'            direction (str): Direction To move, 'forward', 'back', 'right' or 'left'.
'            distance (int|float): Distance To move.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        distance = float(distance)
'
'        If self.imperial Is True:
'            distance = int(Round(distance * 30.48))
'        Else:
'            distance = int(Round(distance * 100))
'
'        Return self.send_command('%s %s' % (direction, distance))
'
'    def move_backward(self, distance):
'        """Moves backward for a distance.
'        See comments For Tello.move().
'        Args:
'            distance (int): Distance To move.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        Return self.move('back', distance)
'
'    def move_down(self, distance):
'        """Moves down for a distance.
'        See comments For Tello.move().
'        Args:
'            distance (int): Distance To move.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        Return self.move('down', distance)
'
'    def move_forward(self, distance):
'        """Moves forward for a distance.
'        See comments For Tello.move().
'        Args:
'            distance (int): Distance To move.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'        Return self.move('forward', distance)
'
'    def move_left(self, distance):
'        """Moves left for a distance.
'        See comments For Tello.move().
'        Args:
'            distance (int): Distance To move.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'        Return self.move('left', distance)
'
'    def move_right(self, distance):
'        """Moves right for a distance.
'        See comments For Tello.move().
'        Args:
'            distance (int): Distance To move.
'        """
'        Return self.move('right', distance)
'
'    def move_up(self, distance):
'        """Moves up for a distance.
'        See comments For Tello.move().
'        Args:
'            distance (int): Distance To move.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        Return self.move('up', distance)
'
'    def send_command(self, Command):
'        """Sends a command to the Tello and waits for a response.
'        If self.command_timeout Is exceeded before a response Is received,
'        a RuntimeError exception Is raised.
'        Args:
'            Command (str): Command To send.
'        Returns:
'            str: Response from Tello.
'        Raises:
'            RuntimeError: If no response Is received within self.timeout seconds.
'        """
'
'        self.abort_flag = False
'        timer = threading.Timer(self.command_timeout, self.set_abort_flag)
'
'        self.socket.sendto(Command.encode('utf-8'), self.tello_address)
'
'        timer.start()
'
'        While self.response Is None:
'            If self.abort_flag Is True:
'                raise RuntimeError('No response to command')
'
'        timer.cancel()
'
'        response = self.response.decode('utf-8')
'        self.response = None
'
'        Return response
'
'    def set_abort_flag(self):
'        """Sets self.abort_flag to True.
'        Used by the timer in Tello.send_command() To indicate To that a response
'        timeout has occurred.
'        """
'
'        self.abort_flag = True
'
'    def set_speed(self, speed):
'        """Sets speed.
'        This method expects KPH Or MPH. The Tello API expects speeds from
'        1 To 100 centimeters/second.
'        Metric: .1 To 3.6 KPH
'        Imperial: .1 To 2.2 MPH
'        Args:
'            speed (int|float): Speed.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        speed = float(speed)
'
'        If self.imperial Is True:
'            speed = int(Round(speed * 44.704))
'        Else:
'            speed = int(Round(speed * 27.7778))
'
'        Return self.send_command('speed %s' % speed)
'
'    def TakeOff(self):
'        """Initiates take-off.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        Return self.send_command('takeoff')
'
'    def rotate_cw(self, degrees):
'        """Rotates clockwise.
'        Args:
'            degrees (int): Degrees To rotate, 1 To 360.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'
'        Return self.send_command('cw %s' % degrees)
'
'    def rotate_ccw(self, degrees):
'        """Rotates counter-clockwise.
'        Args:
'            degrees (int): Degrees To rotate, 1 To 360.
'        Returns:
'            str: Response from Tello, 'OK' or 'FALSE'.
'        """
'        Return self.send_command('ccw %s' % degrees)